/**
 * Created by HBuilder.
 * User: tyx
 * Date: 2019-1-16
 * Time: 13:57:51
 */
/**
 * 图片压缩功能
 */

/**
 * 压缩功能使用示例
 */
//--------文件上传功能
//--------plus相机拍摄
function camera(){
	var cmr = plus.camera.getCamera();
	cmr.captureImage(function(path) {
		var content = "file://" + plus.io.convertLocalFileSystemURL(path);
			plusImg(content);
	}, function(err) {
			
	});
}
//-------plus相册拍摄
function gallery(){
	plus.gallery.pick(function(path) {
		plusImg(path);
	}, function(err) {
		
	}, null);
}
//-------针对plus上传的图片进行处理
function plusImg(path){
	var form = new FormData();
	var compress=new Compress();
	plus.io.resolveLocalFileSystemURL(path, function(entry) {	//--调用IO文件文件管理系统
		entry.file(function(file) {
			var fileReader = new plus.io.FileReader();
			console.log("getFile:" + JSON.stringify(file));			//--调取文件信息
			console.log("文件大小是"+file.size);						//--文件大小
			var qualityFile=(file.size>1025)?0.2:1;
			compress.canvasDataURL(path, {quality: qualityFile}, function(base64Codes){
		    	var bl = compress.convertBase64UrlToBlob(base64Codes);	  		//转为blob类型					 				  // 文件对象
		        form.append("file", bl, "file_"+Date.parse(new Date())+".jpg"); 
		        upAjax(form);									 		//调用图片上传接口
	    	})
		});
	}, function(e) {
		alert("系统文件错误日志: " + e.message);
	});
}

//--------web端网页上传
function webfile(that){
	var fileObj=that.files[0];
	var form = new FormData();
	var compress=new Compress();
	if(fileObj.size/1024>1025){
		//----调用图片压缩处理工具
		compress.photoCompress(fileObj, {
            quality: 0.2									  //压缩比例
        }, function(base64Codes){							  //图片压缩后的base64编码			  
            var bl = compress.convertBase64UrlToBlob(base64Codes);	  //转为blob类型							 				  // 文件对象
            form.append("file", bl, "file_"+Date.parse(new Date())+".jpg"); 
            upAjax(form);									 //调用图片上传接口
        });
	}else{
		form.append("file", fileObj);
		upAjax(form);
	}
}

//---------ajax调用上传接口

//--------统一上传接口
function upAjax(formData) {
    $.ajax({
        url:"http://ipa.早健康.net/myg/upload/upload",
        type:"post",
        data:formData,
        processData: false,
        contentType: false,
        success:function(data){
        	console.log(JSON.stringify(data.data[0]))
           //返回正确的逻辑处理
           $(".showImg").append('<img src="http://ipa.早健康.net'+data.data[0]+'">');
        },
        error:function(data){
          //错误处理
        }
    })
}

//---------封装一个闭包的压缩类
var Compress = (function(window) {
	var Compress = function() {
	    return new Compress.fn.init();
	}

	Compress.fn = Compress.prototype = {
	    constructor: Compress,
	    init: function() {
//	        this.name = name;
//	        this.sayHello = function() {
//	            this.makeArray();
//	        }
	    },
		//----------------web端递归上传
		/**
		 * 分享时传入的必要参数
		 * @param  {int}     	i   				默认传入0
		 * @param  {obj}   		file   	                        批量上传的图片对象
		 * @param  {--}   	    formData   			实例化的formData表单
		 * @param  {function}   fun   				回调函数,处理返回后的业务逻辑,形参为formData值
		 * @return {json}   	obj					(选填)传入的json,可选择值如下(noSize:图片大小超过多少禁止上传(单位k,默认10000),maxSize:超过多少压缩(单位k,默认1000),quali:压缩比率0-1之间(默认0.2))
		 * @param  {function}   funno   			(选填)回调函数,当图片过大时执行的函数
		 */
		webMorePic:function(i,file,formData,fun,obj,funno){
			if(i>=file.length){
				fun(formData);
				return;
			};
			if(!obj){
				var obj = {};
			}
			if(!funno){
				function funno(){console.log("上传的图片过大")};
			}
			var noSize = obj.noSize || 10000;
			var maxSize = obj.maxSize || 1000;
			var quali = obj.quality || 0.2;
			var that=this;
			if(file[i].size / 1024 > noSize){funno();return;};
			if(file[i].size / 1024 > maxSize) {
				 this.photoCompress(file[i], {								//--压缩处理
					quality: quali										//压缩比例
				}, function(base64Codes) { 								//图片压缩后的base64编码	
					var bl = that.convertBase64UrlToBlob(base64Codes); 		//转为blob类型
					formData.append("file", bl, "file_" + Date.parse(new Date()) + ".jpg");
					that.webMorePic(i+1,file,formData,fun,obj,funno);					
				});
			}else{
				formData.append("file", file[i]);
				this.webMorePic(i+1,file,formData,fun,obj,funno);
			}
		},
		//-----------读取文件
		/*
		三个参数
		file：一个是文件(类型是图片格式)，
		w：一个是文件压缩的后宽度，宽度越小，字节越小
		objDiv：一个是容器或者回调函数
		photoCompress()
		 */
		photoCompress:function(file,w,objDiv){
		    var ready=new FileReader();
		    var that=this;
		    /*开始读取指定的Blob对象或File对象中的内容. 当读取操作完成时,readyState属性的值会成为DONE,如果设置了onloadend事件处理程序,则调用之.同时,result属性中将包含一个data: URL格式的字符串以表示所读取文件的内容.*/
		    ready.readAsDataURL(file);
		    ready.onload=function(){
		        var re=this.result;
		        that.canvasDataURL(re,w,objDiv)
		    }
		},
		//-------------图片绘制并base64转码
		canvasDataURL:function(path, obj, callback){
		    var img = new Image();
		    img.src = path;
		    img.onload = function(){
		        var that = this;
		        // 默认按比例压缩
		        var w = that.width,
		            h = that.height,
		            scale = w / h;
		        w = obj.width || w;
		        h = obj.height || (w / scale);
		        var quality = 0.7;  // 默认图片质量为0.7
		        //生成canvas
		        var canvas = document.createElement('canvas');
		        var ctx = canvas.getContext('2d');
		        // 创建属性节点
		        var anw = document.createAttribute("width");
		        anw.nodeValue = w;
		        var anh = document.createAttribute("height");
		        anh.nodeValue = h;
		        canvas.setAttributeNode(anw);
		        canvas.setAttributeNode(anh);
		        ctx.drawImage(that, 0, 0, w, h);
		        // 图像质量
		        if(obj.quality && obj.quality <= 1 && obj.quality > 0){
		            quality = obj.quality;
		        }
		        // quality值越小，所绘制出的图像越模糊
		        var base64 = canvas.toDataURL('image/jpeg', quality);
		        // 回调函数返回base64的值
		        callback(base64);
		    }
		},
		//---------将以base64的图片url数据转换为Blob
		/**
		 * @param urlData
		 * 用url方式表示的base64图片数据
		 */
		convertBase64UrlToBlob:function (urlData){
		    var arr = urlData.split(','), mime = arr[0].match(/:(.*?);/)[1],
		        bstr = atob(arr[1]), n = bstr.length, u8arr = new Uint8Array(n);
		    while(n--){
		        u8arr[n] = bstr.charCodeAt(n);
		    }
		    return new Blob([u8arr], {type:mime});
		},
		//----------获取base64图片大小，返回MB数字
		showSize:function (base64url) {
		    var str = base64url.replace('data:image/jpeg;base64,', '');
		    
		    var equalIndex = str.indexOf('=');
		    if(str.indexOf('=')>0) {
		        str=str.substring(0, equalIndex);
		    }
		    
		    var strLength=str.length;
		    
		    var fileLength=parseInt(strLength-(strLength/8)*2);
		    console.log("```````````````"+strLength);
		    // 由字节转换为MB
		    var size = "";
		    size = (fileLength/(1024 * 1024)).toFixed(2);
		    console.log("```````````````"+size);
		    var sizeStr = size + "";                        //转成字符串
		    var index = sizeStr.indexOf(".");                    //获取小数点处的索引
		    var dou = sizeStr.substr(index + 1 ,2)            //获取小数点后两位的值
		    if(dou == "00"){                                //判断后两位是否为00，如果是则删除00                
		        return sizeStr.substring(0, index) + sizeStr.substr(index + 3, 2)
		    }
		    return parseInt(size);
		}
	}
	Compress.fn.init.prototype = Compress.fn;
	return Compress;
})();