mui.init();
mui('.mui-scroll-wrapper').scroll();
//---------配置量
var urls = surl; //接口地址(来源:server.js)
var tokens = token; //单点验证的token值(来源alltoken.js)

var vm = new Vue({
        el: '.abc',
        data: {
        	times: {},
            list:[],
            morningTime:{},
            afternoonTime:{},
            eveningTime:{},
            isActive:false,
            isState:false,
            picker: null,
            docId: ''
        },
        mounted: function () {
        	if(GetRequest().state){
        		this.docId = GetRequest().docId;
        		this.isState = true;
        	}else{
        		this.docId = localStorage.getItem("doc_id"); //医生id
        	}
        	this.ajaxReturn();
        },
        methods: {
        	/**
        	 * ajax
        	 */
        	ajaxReturn: function(){
        		var that = this;
	        	$.ajax({
	        		type:"post",
	        		url:urls+"/doctorCard/selectTime",
	        		headers:{
						token: tokens
	        		},
	        		data: {
	        			doc_id: that.docId
	        		},
	        		success: function(res){
	        			if(!res.data){
	        				that.times = {
	        					"morning":"00:00-00:00",
	        					"noon":"00:00-00:00",
	        					"evening":"00:00-00:00",
	        					"hospital_name":""
	        				}
	        			}else{
	        				that.times = res.data;
	        			}
	        			
	        			if(res.datas.length==0){
	        				that.list = [
							    {
							        "visit_day": "1",
							        "forenoon": 0,
							        "afternoon": 0,
							        "night": 0
							    },
							    {
							        "visit_day": "2",
							        "forenoon": 0,
							        "afternoon": 0,
							        "night": 0
							    },
							    {
							        "visit_day": "3",
							        "forenoon": 0,
							        "afternoon": 0,
							        "night": 0
							    },
							    {
							        "visit_day": "4",
							        "forenoon": 0,
							        "afternoon": 0,
							        "night": 0
							    },
							    {
							        "visit_day": "5",
							        "forenoon": 0,
							        "afternoon": 0,
							        "night": 0
							    },
							    {
							        "visit_day": "6",
							        "forenoon": 0,
							        "afternoon": 0,
							        "night": 0
							    },
							    {
							        "visit_day": "7",
							        "forenoon": 0,
							        "afternoon": 0,
							        "night": 0
							    }
							]
	        			}else{
	        				that.list = res.datas;
	        			}
	        			
	        			that.morningTime = {
	        				"start": that.times.morning.split('-')[0],
	        				"end": that.times.morning.split('-')[1]
	        			};
	        			that.afternoonTime = {
	        				"start": that.times.noon.split('-')[0],
	        				"end": that.times.noon.split('-')[1]
	        			}
	        			that.eveningTime = {
	        				"start": that.times.evening.split('-')[0],
	        				"end": that.times.evening.split('-')[1]
	        			}
	        			
	        		},
	        		error: function(){
	        			
	        		}
	        	});
        	},
        	/**
        	 * 选择值班时间
        	 * @param {Object} indexs
        	 * @param {Object} identifying
        	 * @param {Object} state
        	 */
            choice: function(indexs,identifying,state){
            	if(this.isState){
            		return;
            	}
            	if(state==1){
            		this.list[indexs][identifying] = 0;
            	}else if(state==0){
            		this.list[indexs][identifying] = 1;
            	}
            },
            /**
             * 修改工作时间
             */
            updateTime: function(){
            	var that = this;
            	
//          	var morningTime = that.morningTime.start+'-'+that.morningTime.end;
//          	var afternoonTime = that.afternoonTime.start+'-'+that.afternoonTime.end;
//          	var eveningTime = that.eveningTime.start+'-'+that.eveningTime.end;
            	
            	$.ajax({
	        		type:"post",
	        		url:urls+"/doctorCard/updateTime",
	        		headers:{
						token:tokens
	        		},
	        		async:false,
	        		data: {
	        			doc_id: that.docId,
	        			morning:that.times.morning,
	        			noon: that.times.noon,
	        			evening: that.times.evening
	        		},
	        		success: function(res){
	        			if(res.success!=0){
	        				console.log('修改失败',res);
	        			}
	        			//mui.toast( "修改成功");
	        		},
	        		error: function(res){
	        			console.log('接口异常',res);
	        		}
	        	});
            },
            /**
             * 修改值班时间
             */
            updateVisit: function(){
            	var that = this;
            	//JSON.stringify(that.list)
            	
            	var result = JSON.stringify(that.list);
            	
            	$.ajax({
	        		type:"post",
	        		url:urls+"/doctorCard/updateVisit",
	        		headers:{
						token: tokens
	        		},
	        		async:false,
	        		data: {
	        			doc_id: that.docId,
	        			lists: result
	        		},
	        		success: function(res){
	        			if(res.success!=0){
	        				console.log('修改失败',res);
	        			}
	        			mui.toast( "修改成功");
	        		},
	        		error: function(res){
	        			console.log('接口异常',res);
	        		}
	        	});
            },
            /**
             * 用户保存
             */
            submits: function(){
            	var mask = mui.createMask();//callback为用户点击蒙版时自动执行的回调；
				mask.show();//显示遮罩
            	this.updateTime();
            	this.updateVisit();
            	mask.close();//关闭遮罩
            }
        }
    })
/**
 * 监听事件 时间选择器
 */
var btns = $('.time1');
btns.each(function(i, btn) {
	btn.addEventListener('tap',function(){
		var _self = this;
		if(_self.picker) {//时间选择器是否存在，若存在则关闭，并将记录的vm.picker清空
			_self.picker.hide();
			_self.picker.dispose();
			_self.picker = null;
			vm.picker = null;
		} else {//时间选择器是否存在，若不存在则创建，并记录的vm.picker
			if(vm.picker){//若vm.picker存在，则关闭vm.picker
				vm.picker.picker.hide();
				vm.picker.picker.dispose();
				vm.picker.picker = null;
			}
			var optionsJson;
			var options;
			//上午
			optionsJson = {
				"type":"time",
				"beginDate": new Date("2019-1-24 00:00:00"),
				"endDate":new Date('2019-1-24 12:00:00 ')
			};
			//下午
			optionsJson2 = {
				"type":"time",
				"beginDate": new Date("2019-1-24 12:01:00"),
				"endDate":new Date('2019-1-24 18:00:00:00 ')
			};
			//晚上
			optionsJson3 = {
				"type":"time",
				"beginDate": new Date("2019-1-24 18:01:00"),
				"endDate":new Date('2019-1-24 23:59:00:00 ')
			};
			
			i==0 || i==1 ?options = optionsJson:optionss={};
			i==2 || i==3 ?options = optionsJson2:optionss={};
			i==4 || i==5 ?options = optionsJson3:optionss={};

			_self.picker = new mui.DtPicker(options);
			vm.picker = _self;//记录vm.picker
			_self.picker.show(function(rs) {
				i==0 ? vm.morningTime.start = rs.text : '';
				i==1 ? vm.morningTime.end = rs.text : '';
				i==2 ? vm.afternoonTime.start = rs.text : '';
				i==3 ? vm.afternoonTime.end = rs.text : '';
				i==4 ? vm.eveningTime.start = rs.text : '';
				i==5 ? vm.eveningTime.end = rs.text : '';
				
            	if(Number(vm.morningTime.end.split(":")[0])<Number(vm.morningTime.start.split(":")[0]) || Number(vm.afternoonTime.end.split(":")[0])<Number(vm.afternoonTime.start.split(":")[0]) || Number(vm.eveningTime.end.split(":")[0])<Number(vm.eveningTime.start.split(":")[0])){
            		mui.toast("时间格式存在错误,请重新设置");
//          		_self.picker.dispose();
//					_self.picker = null;
            		return;
            	}
            	
				vm.times = {
					"morning":vm.morningTime.start+"-"+vm.morningTime.end,
					"noon":vm.afternoonTime.start+"-"+vm.afternoonTime.end,
					"evening":vm.eveningTime.start+"-"+vm.eveningTime.end,
					"hospital_name": vm.times.hospital_name
				}
				console.log(vm.times);
            	$(_self).val(rs.text);
			});
			
		}
	},false)
});